---
categories: cloud storage
title: Multi Slave DRBD9
...

* Documentation : <https://linbit.com/drbd-user-guide/drbd-guide-9_0-en/>

Depuis DRBD-9, il n'est plus nécessaire de mettre en place la danse de DRBD pour utiliser plusieurs nœuds.

**Attention :** Ce wiki explique comment installer DRBD-9 et mettre en place plusieurs nœuds. Pour une explication de l'utilisation générale de DRBD, veuillez vous référer à la page : <https://wiki.evolix.org/HowtoDRBD>

## Installation

Pour une installation via les paquets fournis par LINSTOR, vous devez ajouter un fichier .sources dans /etc/apt/sources.list.d/.

~~~
echo "
Types: deb
URIs: https://packages.linbit.com/public
Enabled: yes
Suites: proxmox-8
Components: drbd-9
Signed-by: /etc/apt/trusted.gpg.d/linbit-keyring.gpg
" > /etc/apt/sources.list.d/drbd.sources
~~~

Ensuite, mettez à jour les sources et certaines dépendances via :

~~~
apt update
apt upgrade
~~~

Enfin, installez les paquets grâce au dkms fourni dans le référentiel de LINSTOR :

`apt install drbd-dkms`

Pour vérifier si le module drbd est déjà chargé, vérifiez simplement si le fichier /proc/drbd existe. Si le module est chargé, redémarrez la machine.

Vous pouvez ensuite charger le module: `modprobe drbd`.



## Mise en place de plusieurs noeuds

Voici un exemple d'une ressource similaire au HowToDRBD, nommée "foo" :


~~~
resource "foo" {
    volume 0 {
        device minor 42;
        disk /dev/sdz1;
        meta-disk internal;
    }
    on tic {
        address 192.0.2.1:7014;
    }
    on tac {
        address 192.0.2.2:7014;
    }
}
~~~

Pour chaque nœud, ajoutez un node-id :

~~~
    on tic {
        address 192.0.2.1:7014;
        node-id 0;
    }
    on tac {
        address 192.0.2.2:7014;
        node-id 1;
    }
    on toc {
        address 192.0.2.3:7014;
        node-id 2;
    }
~~~

Afin d'énumérer tous les nœuds participants, ajoutez la directive :

~~~
connection-mesh {
  hosts tic tac toc;
}
~~~
Votre configuration DRBD est désormais prête à être utilisée.